=== contrib/debian/changelog ===
freediameter (1.2.0) UNRELEASED; urgency=low

  * Major changes in the logging system to be more syslog and production friendly
  * New extension: dict_dcca_3gpp
  * New extension: dict_dcca_starent (Starent DCCA vendor-specific AVPs)
  * New extension: rt_ignore_dh (hide network topology by proxying Destination-Host).
  * New extension: rt_load_balance (load balancer based on pending queue size).
  * New extension: rt_busypeers. See doc/rt_busypeers.conf.sample.
  * New extension: dbg_msg_timings. Measures timing of message operations.
  * New extension: dbg_msg_dumps. Use to control hooks display.
  * New API (fd_hook_*) for extensions to control messages logging & profiling
  * New API (fd_stats_*) for extensions to monitor framework state (e.g. SNMP implem)
  * API change: all the fd_*_dump functions now return malloc'd strings instead of logging directly.
  * API change: callback parameter of fd_rt_out_register had its signature updated.
  * Updated dbg_monitoring extension to use the new API
  * New script to generate dictionary extensions from org file (see contrib/tools)
  * New compilation option: WORKAROUND_ACCEPT_INVALID_VSAI to improve compatibility
    with invalid Vendor-Specific-Application-Id AVPs received from some equipments (e.g. Cisco).
  * New compilation option: DISABLE_PEER_EXPIRY for use in test environments.
  * Extensions are now also searched in LD_LIBRARY_PATH.
  * Copy Proxy-Info AVP automatically in new answers.
  * Port value 0 allowed in configuration to disable local server (e.g. disable non-secure port).
  * API change: fd_msg_send_timeout now takes a separate callback for timeout situation.
  * Function changes: fd_msg_dump_* now split in three different type of output.
  * New test testmesg_stress to measure message parser performance
  * Fix termination of the framework to avoid failures.
  * Fix invalid timespec value in peer PSM appearing randomly (leading to crash).
  * Return DIAMETER_LOOP_DETECTED if local peer in the Route-Record list of a message.
  * Allow running without TLS configuration.
  * Upgraded SCTP code to comply with RFC 6458
  * Using default secure Diameter port number 5658 as per RFC 6733
  * Updated TLS code for performance improvements with new GNU TLS.
  * Fix interlocking problem when large number of requests were failed over.
  * New option in test_app.fdx extension for long messages payload.
  * Performance improvement in message sending code path.

 -- Sebastien Decugis <sdecugis@freediameter.net>  Sat, 14 Sep 2013 18:08:07 +0800

freediameter (1.1.6) UNRELEASED; urgency=low

  * Fix major issue in 1.1.5 preventing to send answers to a received message.
  * New command-line option: --enable_msg_log=( DROPPED | RECEIVED | SENT | NODELIVER | TIMING )
  * Improved parsing error handling and Failed-AVP generation.
  * Added support for some timings measurements in freeDiameter (in the logs)
  * Fix port handling when using non-default port.
  * Some cleanups in several dictionary files.
  * New option to fd_dict_search: AVP_BY_STRUCT
  * Improved compatibility with C++ compilers.
  * Cleanups in sessions creation/destruction to avoid memory corruption under stress.
  * Add support for "include" directive in freeDiameter.conf file.

 -- Sebastien Decugis <sdecugis@freediameter.net>  Sun, 03 Mar 2013 07:40:43 +0100

freediameter (1.1.5) UNRELEASED; urgency=low

  * Added compatibility with MAC OS X
  * Fix behavior of timeout whe nsending messages to allow re-send.
  * Several cleanups and new contributions included.
  * Added dependency on C++ compiler for CMakeLists.txt

 -- Sebastien Decugis <sdecugis@freediameter.net>  Sat, 03 Nov 2012 17:58:11 +0100

freediameter (1.1.4) UNRELEASED; urgency=low

  * Compatibility with GnuTLS 3.x versions / updated packaging files accordingly
  * Fix crash on Sparc 64 (possibly other 64b machines)
  * Updated dict_dcca in extensions and contrib (thanks Konstantin)
  * Changed dumping of messages to avoid interleaved information

 -- Sebastien Decugis <sdecugis@freediameter.net>  Fri, 24 Aug 2012 00:17:05 +0200

freediameter (1.1.3) UNRELEASED; urgency=low

  * Fixed a memory leak
  * Clean-up of some extensions

 -- Sebastien Decugis <sdecugis@freediameter.net>  Tue, 03 Jul 2012 08:15:49 +0200

freediameter (1.1.2) UNRELEASED; urgency=low

  * FIFO queues are now capped to avoid memory exhaustion.
  * Cleanups in MIPv6 dictionaries.
  * app_acct upgraded: enabled vendor-specific AVP logging, thread-safe version.
  * New function: fd_dict_getlistof to list dictionary contents.
  * New function: fd_dict_delete to remove an entry (dangerous function!)
  * New function: fd_sess_getcount to get count of session objects.
  * A few additional bug fixes, check hg log for details.

 -- Sebastien Decugis <sdecugis@freediameter.net>  Tue, 21 Feb 2012 18:38:10 +0100

freediameter (1.1.1) UNRELEASED; urgency=low

  * Bug fix release
  * Supports newer GNUTLS versions
  * Allow empty OctetString AVPs (l=0)
  * Allow two instances of freeDiameter on a single host.

 -- Sebastien Decugis <sdecugis@nict.go.jp>  Fri, 30 Sep 2011 21:56:50 +0200

freediameter (1.1.0) UNRELEASED; urgency=low

  * Source package restructured. Most of the 
    framework now contained in the libfdcore library.
    libfreeDiameter renamed as libfdproto.
    This closes #15.
  * API version bumped to version 4.
  * Improved fd_dict_new() when the same object already exists.
  * Improvements to dict_legacy_xml extension.
  * Cleanups in links to shared libraries
  * (app_radgw.fdx) Better handling conversion of DEA with error status
    to RADIUS (closes #25)
  * Allow default signals such as SIGTSTP (ctrl-z) to be used with
    freeDiameterd
  * Improved DiameterIdentity handling (esp. interationalization issues), 
    and improve efficiency of some string operations in peers, sessions, 
    and dictionary modules (closes #7)
  * Cleanup in the session module to free only unreferenced sessions (#16)

